apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ rgw_name }}
  name: {{ rgw_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ radosgw_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ rgw_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ rgw_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ rgw_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ rgw_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ rgw_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: CLUSTER
          value: {{ ceph_cluster_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: RGW_NAME
          value: {{ radosgw_keyring_name }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='radosgw'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='radosgw'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 8080
        name: radosgw
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /
            port: 8080
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ radosgw_cpu_limit }}"
            memory: "{{ radosgw_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ radosgw_cpu_limit }}"
            memory: "{{ radosgw_memory_limit }}"
{% else %}
            cpu: "{{ radosgw_cpu_request }}"
            memory: "{{ radosgw_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/lib/ceph/radosgw/{{ ceph_cluster_name }}-rgw.{{ radosgw_keyring_name }}/keyring
          name: conf
          subPath: {{ ceph_cluster_name }}.client.{{ radosgw_keyring_name }}.gateway.keyring
        - mountPath: /etc/ceph
          name: conf
{% if do_exporters %}
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: RADOSGW_HOST
          value: 127.0.0.1
        - name: RADOSGW_PORT
          value: "8080"
        - name: ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name }}-exporter
        - name: SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name }}-exporter
{% if do_triggers == False or (opsimages | json_query("[?name=='rgwexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='rgwexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
          timeoutSeconds: 5
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ rgw_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: conf
        secret:
          defaultMode: 420
          secretName: {{ rgw_name }}-conf
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='radosgw'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - radosgw
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='radosgw'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='rgwexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='rgwexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
